﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Graphics.Display;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

namespace Brooks.Controls.WinRT.Test
{
    public sealed partial class ReportDemo
    {
        private IList<Uri> __list = new List<Uri>();

        private bool fn是否是有效Url(string v_Url)
        {
            Regex __reg = new Regex(@"^[a-zA-z]+://[^\s]*$");
            if (__reg.IsMatch(v_Url))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private void fn跳转到指定Url(string v_Url)
        {
            if (!v_Url.StartsWith("http://") && !v_Url.StartsWith("https://"))
            {
                v_Url = "http://" + v_Url;
            }

            if (this.fn是否是有效Url(v_Url))
            {
                this.wv.Navigate(new Uri(v_Url));
            }
            else
            {
                this.wv.NavigateToString(@"<html><h3>404</h3></html>");
            }
        }

        private void fn后退(Uri v_Uri)
        {
            if (this.__list.Count > 1)
            {
                int __当前网页索引 = -1;
                __当前网页索引 = this.__list.IndexOf(v_Uri);

                if (__当前网页索引 >= 1)
                {
                    this.wv.Navigate(this.__list[__当前网页索引 - 1]);
                }
            }
            else
            {

            }
        }

        private void fn前进(Uri v_Uri)
        {
            if (this.__list.Count > 1)
            {
                int __当前网页索引 = -1;
                __当前网页索引 = this.__list.IndexOf(v_Uri);

                if (__当前网页索引 < this.__list.Count - 1)
                {
                    this.wv.Navigate(this.__list[__当前网页索引 + 1]);
                }
            }
            else
            {

            }
        }

        public ReportDemo()
        {
            InitializeComponent();
        }

        // View state management for switching among Full, Fill, Snapped, and Portrait states

        private DisplayPropertiesEventHandler _displayHandler;
        private TypedEventHandler<ApplicationLayout, ApplicationLayoutChangedEventArgs> _layoutHandler;

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            if (_displayHandler == null)
            {
                _displayHandler = Page_OrientationChanged;
                _layoutHandler = Page_LayoutChanged;
            }
            DisplayProperties.OrientationChanged += _displayHandler;
            ApplicationLayout.GetForCurrentView().LayoutChanged += _layoutHandler;
            SetCurrentOrientation(this);
        }

        private void Page_Unloaded(object sender, RoutedEventArgs e)
        {
            DisplayProperties.OrientationChanged -= _displayHandler;
            ApplicationLayout.GetForCurrentView().LayoutChanged -= _layoutHandler;
        }

        private void Page_LayoutChanged(object sender, ApplicationLayoutChangedEventArgs e)
        {
            SetCurrentOrientation(this);
        }

        private void Page_OrientationChanged(object sender)
        {
            SetCurrentOrientation(this);
        }

        private void SetCurrentOrientation(Control viewStateAwareControl)
        {
            VisualStateManager.GoToState(viewStateAwareControl, this.GetViewState(), false);
        }

        private String GetViewState()
        {
            var orientation = DisplayProperties.CurrentOrientation;
            if (orientation == DisplayOrientations.Portrait ||
                orientation == DisplayOrientations.PortraitFlipped) return "Portrait";
            var layout = ApplicationLayout.Value;
            if (layout == ApplicationLayoutState.Filled) return "Fill";
            if (layout == ApplicationLayoutState.Snapped) return "Snapped";
            return "Full";
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.fn后退(this.wv.Source);
        }

        private void btnNext_Click(object sender, RoutedEventArgs e)
        {
            this.fn前进(this.wv.Source);
        }

        private void btnGo_Click(object sender, RoutedEventArgs e)
        {
            this.fn跳转到指定Url(this.txtUrl.Text);
        }

        private void btnRefresh_Click(object sender, RoutedEventArgs e)
        {
            this.wv.Navigate(this.wv.Source);
        }

        private void UserControl_KeyUp(object sender, Windows.UI.Xaml.Input.KeyEventArgs e)
        {
            if (e.Key == Windows.System.VirtualKey.Enter)
            {
                this.fn跳转到指定Url(this.txtUrl.Text);
            }
        }

        private void wv_LoadCompleted(object sender, Windows.UI.Xaml.Navigation.NavigationEventArgs e)
        {
            string v_Url = e.Uri.ToString();
            if (!v_Url.StartsWith("http://") && !v_Url.StartsWith("https://"))
            {
                v_Url = "http://" + v_Url;
            }

            if (this.fn是否是有效Url(v_Url))
            {
                if (!this.__list.Contains(new Uri(v_Url)))
                {
                    this.__list.Add(new Uri(v_Url));
                }
            }
        }
    }
}
